SystemOrganization addCategory: #'TP Integrador'!

Object subclass: #Condicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Condicion subclass: #Confundido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Confundido methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
tePodesMover 
^false. ! !

Condicion subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Dormido methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:46'!
tePodesMover 
^Moneda flip ifTrue:[^true and self condicion:Normal]
ifFalse:[^false]. ! !

Condicion subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Normal methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:20'!
tePodesMover
^true.! !

Condicion subclass: #Paralizado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralizado methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:49'!
tePodesMover 
Moneda flip ifTrue:[^true]
ifFalse:[^false].! !

Object subclass: #ErrorDebesDebilitarloMas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Object subclass: #EstePokemonYaTieneDuenioError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Object subclass: #Movimiento
	instanceVariableNames: 'usosDisponibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:11'!
estasDisponible
^usosDisponibles >0.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:14'!
unUsoMenos 
usosDisponibles:=usosDisponibles -1.! !

Movimiento subclass: #MovimientoCurativo
	instanceVariableNames: 'puntosDeVida puntosACurar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:36'!
aplicarEfectoA: otroPokemon
otroPokemon curate:puntosACurar.! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:35'!
cuantoPoderSumas 
^puntosACurar. ! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:44'!
puntosACurar:unaCantidad
puntosACurar:=unaCantidad.! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
sosConvenienteContra:otroPokemon
^otroPokemon tusPuntosDeVida =50 and:[(otroPokemon tePuedenSacrificar)not]. ! !

Movimiento subclass: #MovimientoDanino
	instanceVariableNames: 'puntosDeDao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:46'!
aplicarEfectoA:otroPokemon
otroPokemon teDaaron:puntosDeDao.! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:46'!
cuantoPoderSumas 
^puntosDeDao *2.! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:47'!
puntosDeDao:unaCantidad
puntosDeDao:=unaCantidad. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:35'!
sosConvenienteContra: unPokemon
^(self puntosDeDao - unPokemon tusPuntosDeVida) < 50  | ((unPokemon movimientosDisponibles) count:[:movimiento|movimiento class=MovimientoDanino])>1 . 
! !

Movimiento subclass: #MovimientoEspecial
	instanceVariableNames: 'condicionAAplicar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

MovimientoEspecial subclass: #Confusion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Confusion methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:20'!
aplicarEfectoA:otroPokemon
otroPokemon quedas:Confundido.
otroPokemon teAutoGolpeas. ! !

!Confusion methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:21'!
cuantoPoderSumas 
^40. ! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:12'!
sosConvenienteContra:otroPokemon
otroPokemon cuantaGrositudTenes > (self cuantaGrositudTenes *2) and:[otroPokemon condicion:Normal] "Aca yo no se si funciona como quiero el self en la parte de "self cuantaGrositudTenes"habria que probarlo pero creo que falla".! !

MovimientoEspecial subclass: #Paralisis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralisis methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:15'!
aplicarEfectoA: otroPokemon
otroPokemon quedas:Paralizado.! !

!Paralisis methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:52'!
cuantoPoderSumas 
^30.! !

MovimientoEspecial subclass: #Suenio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Suenio methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:16'!
aplicarEfectoA: otroPokemon
otroPokemon quedas:Dormido.! !

!Suenio methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:52'!
cuantoPoderSumas 
^50. ! !

Object subclass: #NoTePodesMover
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Object subclass: #Objeto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Objeto subclass: #Medicina
	instanceVariableNames: 'cantidadQueCura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
aplicarEn:unPokemon
unPokemon curate:cantidadQueCura.! !

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
cantidadQueCura:unaCantidad
cantidadQueCura:=unaCantidad. ! !

Objeto subclass: #MedicinaEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MedicinaEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:35'!
aplicarEn:unPokemon
unPokemon condicion:Normal.! !

Objeto subclass: #Pokebola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokebola methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
aplicarEn:unPokemon

unPokemon tusPuntosDeVida < (unPokemon tusPuntosDeVidaMax / 2) ifFalse:[ErrorDebesDebilitarloMas signal].

^unPokemon tieneEntrenador  ifTrue:[EstePokemonYaTieneDuenioError signal]
											    ifFalse:[unPokemon entrenador:ConEntrenador].! !

Object subclass: #Pokemon
	instanceVariableNames: 'movimientos puntosDeVida puntosDeVidaMax condicion entrenador experiencia ganadores movimientosDisponibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Pokemon subclass: #ConEntrenador
	instanceVariableNames: 'pokemones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:44'!
initialize 
pokemones:=Set new. ! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
tePuedenSacrificar 
^(pokemones count:[:unPokemon|unPokemon podesLuchar])>2 and:[self cuantaGrositudTenes > (pokemones collect:[:unPokemon|unPokemon cuantaGrositudTenes])max]. ! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^true.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:50'!
condicion
^condicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:11'!
condicion:unObjeto
condicion:=unObjeto. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:31'!
cuantaGrositudTenes
^self nivel * self sumaMovimientos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:01'!
curate:unosPuntos
puntosDeVida:=puntosDeVida + (unosPuntos).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/22/2013 23:55'!
entrenador
^entrenador.
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/22/2013 23:55'!
entrenador:unEntrenador
entrenador:=unEntrenador! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 17:15'!
experiencia 
^experiencia. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:09'!
experiencia:unaCantidad
experiencia:=unaCantidad.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:07'!
initialize
movimientos:=Set new. 
movimientosDisponibles:=Set new. 
self condicion:Normal.
ganadores:=Set new. 
self experiencia:0. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:25'!
luchaCon:unMovimiento contra:otroPokemon
self condicion tePodesMover ifFalse:[NoTePodesMover signal].
self movimiento:unMovimiento contra:otroPokemon.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:13'!
movimiento:unMovimiento contra:otroPokemon
unMovimiento aplicarEfectoA:otroPokemon.
unMovimiento unUsoMenos. 
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:32'!
movimientosConvenientesContra:otroPokemon
movimientosDisponibles select:[:movimiento|movimiento sosConvenienteContra:otroPokemon].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:31'!
movimientosDisponibles
movimientosDisponibles:= self movimientos select:[:movimiento|movimiento estasDisponible]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:35'!
nivel
^7nthRoot:experiencia floor. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:47'!
podesLuchar
^puntosDeVida >0.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 17:11'!
premiaALosGanadores
^self tusPuntosDeVida =0 ifTrue:[ganadores do:[:unPokemon|unPokemon salisteGanadorContra:self]].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:16'!
quedas: unaCondicion
self condicion:unaCondicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:09'!
salisteGanadorContra:unPokemon
|experienciaASumar|
experienciaASumar:=(unPokemon cuantaGrositudTenes / ganadores size). 
^self tusPuntosDeVida >0 ifTrue:[self experiencia:(self experiencia +experienciaASumar)]. 
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:35'!
sumaMovimientos 
^movimientos sum:[:movimiento|movimiento cuantoPoderSumas]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:21'!
teAutoGolpeas 
puntosDeVida:=puntosDeVida -30. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:02'!
teDaaron:unosPuntos
puntosDeVida:=(puntosDeVida-unosPuntos max:0) . ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:15'!
tusPuntosDeVida
^puntosDeVida.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:19'!
tusPuntosDeVidaMax
^puntosDeVidaMax.! !

Pokemon subclass: #SinEntrenador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
tePuedenSacrificar 
^false.! !

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^false.! !
